---
title: Create an AI custom ruleset
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Static Analysis
---

# Create an AI custom ruleset{% #create-an-ai-custom-ruleset %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                          |
| ----------------- | --------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/static-analysis/ai/rulesets |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/static-analysis/ai/rulesets |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/static-analysis/ai/rulesets      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/static-analysis/ai/rulesets      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/static-analysis/ai/rulesets  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/static-analysis/ai/rulesets     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/static-analysis/ai/rulesets |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/static-analysis/ai/rulesets |

### Overview

Create a new AI custom ruleset for the authenticated organization.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                               | Type   | Description                                                        |
| ------------ | ----------------------------------- | ------ | ------------------------------------------------------------------ |
|              | data                                | object | Request data for creating an AI custom ruleset.                    |
| data         | attributes                          | object | Attributes for creating an AI custom ruleset.                      |
| attributes   | description [*required*]       | string | Base64-encoded full description of the ruleset.                    |
| attributes   | name [*required*]              | string | The ruleset name.                                                  |
| attributes   | short_description [*required*] | string | Base64-encoded short description of the ruleset.                   |
| data         | id                                  | string | The ruleset identifier, which must match the name.                 |
| data         | type                                | enum   | AI custom ruleset resource type. Allowed enum values: `ai_ruleset` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "description": "Ruleset description",
      "name": "my-ai-ruleset",
      "short_description": "Ruleset short description"
    },
    "id": "my-ai-ruleset",
    "type": "ai_ruleset"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
Successfully created
{% tab title="Model" %}
Response containing a single AI custom ruleset.

| Parent field  | Field                               | Type      | Description                                                                                     |
| ------------- | ----------------------------------- | --------- | ----------------------------------------------------------------------------------------------- |
|               | data [*required*]              | object    | Response data for an AI custom ruleset.                                                         |
| data          | attributes [*required*]        | object    | Response attributes of an AI custom ruleset.                                                    |
| attributes    | created_at [*required*]        | date-time | The creation timestamp.                                                                         |
| attributes    | created_by [*required*]        | string    | The identifier of the user who created the ruleset.                                             |
| attributes    | description [*required*]       | string    | Base64-encoded full description of the ruleset.                                                 |
| attributes    | name [*required*]              | string    | The ruleset name.                                                                               |
| attributes    | rules [*required*]             | [object]  | The rules contained in the ruleset.                                                             |
| rules         | created_at [*required*]        | date-time | The creation timestamp.                                                                         |
| rules         | created_by [*required*]        | string    | The identifier of the user who created the rule.                                                |
| rules         | last_revision [*required*]     | object    | The most recent revision of the rule.                                                           |
| last_revision | category [*required*]          | enum      | Rule category Allowed enum values: `SECURITY,BEST_PRACTICES,CODE_STYLE,ERROR_PRONE,PERFORMANCE` |
| last_revision | checksum [*required*]          | string    | Checksum of the revision content.                                                               |
| last_revision | content [*required*]           | string    | Base64-encoded AI model content for this revision.                                              |
| last_revision | created_at [*required*]        | date-time | The creation timestamp.                                                                         |
| last_revision | created_by [*required*]        | string    | The identifier of the user who created the revision.                                            |
| last_revision | cwe [*required*]               | string    | The associated CWE identifier.                                                                  |
| last_revision | description [*required*]       | string    | Base64-encoded full description.                                                                |
| last_revision | directories [*required*]       | [string]  | Directory patterns this rule applies to.                                                        |
| last_revision | execution_mode [*required*]    | enum      | The execution mode for an AI rule revision. Allowed enum values: `auto,manual,always`           |
| last_revision | globs [*required*]             | [string]  | File glob patterns this rule applies to.                                                        |
| last_revision | is_default [*required*]        | boolean   | Whether this is a default Datadog rule.                                                         |
| last_revision | is_published [*required*]      | boolean   | Whether this revision is published.                                                             |
| last_revision | is_testing [*required*]        | boolean   | Whether this revision is for testing only.                                                      |
| last_revision | severity [*required*]          | enum      | Rule severity Allowed enum values: `ERROR,WARNING,NOTICE`                                       |
| last_revision | short_description [*required*] | string    | Base64-encoded short description.                                                               |
| last_revision | version_id [*required*]        | int64     | The version identifier for this revision.                                                       |
| rules         | name [*required*]              | string    | The rule name.                                                                                  |
| attributes    | short_description [*required*] | string    | Base64-encoded short description of the ruleset.                                                |
| data          | id [*required*]                | string    | The ruleset identifier.                                                                         |
| data          | type [*required*]              | enum      | AI custom ruleset resource type. Allowed enum values: `ai_ruleset`                              |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2024-01-01T00:00:00+00:00",
      "created_by": "example-handle",
      "description": "Ruleset description",
      "name": "my-ai-ruleset",
      "rules": [
        {
          "created_at": "2024-01-01T00:00:00+00:00",
          "created_by": "example-handle",
          "last_revision": {
            "category": "SECURITY",
            "checksum": "abc123def456",
            "content": "Content",
            "created_at": "2024-01-01T00:00:00+00:00",
            "created_by": "example-handle",
            "cwe": "79",
            "description": "Ruleset description",
            "directories": [
              []
            ],
            "execution_mode": "auto",
            "globs": [
              "**/*.py"
            ],
            "is_default": false,
            "is_published": false,
            "is_testing": false,
            "severity": "ERROR",
            "short_description": "Ruleset short description",
            "version_id": 1
          },
          "name": "my-ai-rule"
        }
      ],
      "short_description": "Ruleset short description"
    },
    "id": "my-ai-ruleset",
    "type": "ai_ruleset"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="409" %}
Conflict - ruleset already exists
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="412" %}
Precondition Failed - validation error
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/static-analysis/ai/rulesets" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "description": "Ruleset description",
      "name": "my-ai-ruleset",
      "short_description": "Ruleset short description"
    },
    "id": "my-ai-ruleset",
    "type": "ai_ruleset"
  }
}
EOF 
                
##### 

```python
"""
Create an AI custom ruleset returns "Successfully created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.static_analysis_api import StaticAnalysisApi
from datadog_api_client.v2.model.ai_custom_ruleset_data_type import AiCustomRulesetDataType
from datadog_api_client.v2.model.ai_custom_ruleset_request import AiCustomRulesetRequest
from datadog_api_client.v2.model.ai_custom_ruleset_request_attributes import AiCustomRulesetRequestAttributes
from datadog_api_client.v2.model.ai_custom_ruleset_request_data import AiCustomRulesetRequestData

body = AiCustomRulesetRequest(
    data=AiCustomRulesetRequestData(
        attributes=AiCustomRulesetRequestAttributes(
            description="Ruleset description",
            name="my-ai-ruleset",
            short_description="Ruleset short description",
        ),
        id="my-ai-ruleset",
        type=AiCustomRulesetDataType.AI_RULESET,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_ai_custom_ruleset"] = True
with ApiClient(configuration) as api_client:
    api_instance = StaticAnalysisApi(api_client)
    response = api_instance.create_ai_custom_ruleset(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Create an AI custom ruleset returns "Successfully created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_ai_custom_ruleset".to_sym] = true
end
api_instance = DatadogAPIClient::V2::StaticAnalysisAPI.new

body = DatadogAPIClient::V2::AiCustomRulesetRequest.new({
  data: DatadogAPIClient::V2::AiCustomRulesetRequestData.new({
    attributes: DatadogAPIClient::V2::AiCustomRulesetRequestAttributes.new({
      description: "Ruleset description",
      name: "my-ai-ruleset",
      short_description: "Ruleset short description",
    }),
    id: "my-ai-ruleset",
    type: DatadogAPIClient::V2::AiCustomRulesetDataType::AI_RULESET,
  }),
})
p api_instance.create_ai_custom_ruleset(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Create an AI custom ruleset returns "Successfully created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.AiCustomRulesetRequest{
		Data: &datadogV2.AiCustomRulesetRequestData{
			Attributes: &datadogV2.AiCustomRulesetRequestAttributes{
				Description:      "Ruleset description",
				Name:             "my-ai-ruleset",
				ShortDescription: "Ruleset short description",
			},
			Id:   datadog.PtrString("my-ai-ruleset"),
			Type: datadogV2.AICUSTOMRULESETDATATYPE_AI_RULESET.Ptr(),
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateAiCustomRuleset", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStaticAnalysisApi(apiClient)
	resp, r, err := api.CreateAiCustomRuleset(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StaticAnalysisApi.CreateAiCustomRuleset`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `StaticAnalysisApi.CreateAiCustomRuleset`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Create an AI custom ruleset returns "Successfully created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StaticAnalysisApi;
import com.datadog.api.client.v2.model.AiCustomRulesetDataType;
import com.datadog.api.client.v2.model.AiCustomRulesetRequest;
import com.datadog.api.client.v2.model.AiCustomRulesetRequestAttributes;
import com.datadog.api.client.v2.model.AiCustomRulesetRequestData;
import com.datadog.api.client.v2.model.AiCustomRulesetResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createAiCustomRuleset", true);
    StaticAnalysisApi apiInstance = new StaticAnalysisApi(defaultClient);

    AiCustomRulesetRequest body =
        new AiCustomRulesetRequest()
            .data(
                new AiCustomRulesetRequestData()
                    .attributes(
                        new AiCustomRulesetRequestAttributes()
                            .description("Ruleset description")
                            .name("my-ai-ruleset")
                            .shortDescription("Ruleset short description"))
                    .id("my-ai-ruleset")
                    .type(AiCustomRulesetDataType.AI_RULESET));

    try {
      AiCustomRulesetResponse result = apiInstance.createAiCustomRuleset(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling StaticAnalysisApi#createAiCustomRuleset");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Create an AI custom ruleset returns "Successfully created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_static_analysis::StaticAnalysisAPI;
use datadog_api_client::datadogV2::model::AiCustomRulesetDataType;
use datadog_api_client::datadogV2::model::AiCustomRulesetRequest;
use datadog_api_client::datadogV2::model::AiCustomRulesetRequestAttributes;
use datadog_api_client::datadogV2::model::AiCustomRulesetRequestData;

#[tokio::main]
async fn main() {
    let body = AiCustomRulesetRequest::new().data(
        AiCustomRulesetRequestData::new()
            .attributes(AiCustomRulesetRequestAttributes::new(
                "Ruleset description".to_string(),
                "my-ai-ruleset".to_string(),
                "Ruleset short description".to_string(),
            ))
            .id("my-ai-ruleset".to_string())
            .type_(AiCustomRulesetDataType::AI_RULESET),
    );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateAiCustomRuleset", true);
    let api = StaticAnalysisAPI::with_config(configuration);
    let resp = api.create_ai_custom_ruleset(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Create an AI custom ruleset returns "Successfully created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createAiCustomRuleset"] = true;
const apiInstance = new v2.StaticAnalysisApi(configuration);

const params: v2.StaticAnalysisApiCreateAiCustomRulesetRequest = {
  body: {
    data: {
      attributes: {
        description: "Ruleset description",
        name: "my-ai-ruleset",
        shortDescription: "Ruleset short description",
      },
      id: "my-ai-ruleset",
      type: "ai_ruleset",
    },
  },
};

apiInstance
  .createAiCustomRuleset(params)
  .then((data: v2.AiCustomRulesetResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
